# cnos_conditional_command – Execute a single command based on condition on devices running Lenovo CNOS

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- This module allows you to modify the running configuration of a switch. It provides a way to execute a single CNOS command on a network device by evaluating the current running configuration and executing the command only if the specific settings have not been already configured. The CNOS command is passed as an argument of the method. This module functions the same as the cnos_command module. The only exception is that following inventory variable can be specified [“condition = <flag string>”] When this inventory variable is specified as the variable of a task, the command is executed for the network element that matches the flag string. Usually, commands are executed across a group of network devices. When there is a requirement to skip the execution of the command on one or more devices, it is recommended to use this module. This module uses SSH to manage network device configuration.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
clicommand - / required | Default: null | This specifies the CLI command as an attribute to this method. The command is passed using double quotes. The variables can be placed directly on to the CLI commands or can be invoked from the vars directory.
condition - / required | Default: null | If you specify condition=false in the inventory file against any device, the command execution is skipped for that device.

deviceType
string / required

Choices:
- g8272_cnos
- g8296_cnos
- g8332_cnos
- NE0152T
- NE1072T
- NE1032
- NE1032T
- NE10032
- NE2572

This specifies the type of device where the method is executed. The choices NE1072T,NE1032,NE1032T,NE10032,NE2572 are added since Ansible 2.4. The choice NE0152T is added since 2.8

enablePassword string |  | Configures the password used to enter Global Configuration command mode on the switch. If the switch does not request this password, the parameter is ignored.While generally the value should come from the inventory file, you can also specify it as a variable. This parameter is optional. If it is not specified, no default value will be used.
flag - / required | Default: null | If a task needs to be executed, you have to set the flag the same as it is specified in the inventory for that device.
host string / required |  | This is the variable used to search the hosts file at /etc/ansible/hosts and identify the IP address of the device on which the template is going to be applied. Usually the Ansible keyword {{ inventory_hostname }} is specified in the playbook as an abstraction of the group of network elements that need to be configured.
outputfile string / required |  | This specifies the file path where the output of each command execution is saved. Each command that is specified in the merged template file and each response from the device are saved here. Usually the location is the results folder, but you can choose another location based on your write permission.
password string / required |  | Configures the password used to authenticate the connection to the remote device. The value of the password parameter is used to authenticate the SSH session. While generally the value should come from the inventory file, you can also specify it as a variable. This parameter is optional. If it is not specified, no default value will be used.
username string / required |  | Configures the username used to authenticate the connection to the remote device. The value of the username parameter is used to authenticate the SSH session. While generally the value should come from the inventory file, you can also specify it as a variable. This parameter is optional. If it is not specified, no default value will be used.

## Notes

Note

- For more information on using Ansible to manage Lenovo Network devices see https://www.ansible.com/ansible-lenovo.

## Examples

    Tasks : The following are examples of using the module
     cnos_conditional_command. These are written in the main.yml file of the tasks
     directory.
    ---
    - name: Applying CLI template on VLAG Tier1 Leaf Switch1
      cnos_conditional_command:
          deviceType: "{{ hostvars[inventory_hostname]['deviceType'] }}"
          outputfile: "./results/test_conditional_command_
                      {{ inventory_hostname }}_output.txt"
          condition: "{{ hostvars[inventory_hostname]['condition']}}"
          flag: leaf_switch2
          command: "spanning-tree mode enable"

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
msg string | always | Success or failure message Sample: Command Applied

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Anil Kumar Muraleedharan (@amuraleedhar)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.